package org.processmining.indatabasepreprocessing.plugins;

import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginCategory;
import org.processmining.framework.plugin.annotations.PluginLevel;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.indatabasepreprocessing.dialogs.DBConnectionDialog;
import org.processmining.indatabasepreprocessing.parameters.DBConnectionParameter;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;

@Plugin(name = "DB Connection Manager", level = PluginLevel.PeerReviewed, categories = { PluginCategory.Analytics }, parameterLabels = { "Petri Net", "Reachability Graph" }, 
returnLabels = { "DB Connection Parameter" }, returnTypes = { DBConnectionParameter.class }, userAccessible = true, help = DBConnectionManagerHelp.TEXT)
public class DBConnectionManagerPlugin {
	
	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "", email = "", pack = "InDatabasePreprocessing")
	@PluginVariant(variantLabel = "DB Connection Manager", requiredParameterLabels = { 0 })
	public DBConnectionParameter main(UIPluginContext context, Petrinet net) {
		DBConnectionDialog dialog = new DBConnectionDialog(context, net);
		DBConnectionParameter parameter = dialog.setup();
		
		return parameter;
	}
	
	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "", email = "", pack = "InDatabasePreprocessing")
	@PluginVariant(variantLabel = "DB Connection Manager", requiredParameterLabels = { })
	public DBConnectionParameter main(UIPluginContext context) {
		DBConnectionDialog dialog = new DBConnectionDialog(context);
		DBConnectionParameter parameter = dialog.setup();
		
		return parameter;
	}

}
